"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isCommaCentSeparatorNotation = _interopRequireDefault(require("./isCommaCentSeparatorNotation"));

var _isDotCentSeparatorNotation = _interopRequireDefault(require("./isDotCentSeparatorNotation"));

var _matchLongestAtLowest = _interopRequireDefault(require("./matchLongestAtLowest"));

var _normalizeInput = _interopRequireDefault(require("./normalizeInput"));

var _parsePrice = _interopRequireDefault(require("./parsePrice"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = subject => {
  const normalizedSubject = (0, _normalizeInput.default)(subject);
  const formats = [/(?:^|\s)(?:\$|£|€|USD|EUR|GBP)?(\d{1,3}(?:,\d{3})*(?:\.\d{2}))(?:\$|£|€|USD|EUR|GBP)?(?:\s|$|, |\. )/, /(?:^|\s)(?:\$|£|€|USD|EUR|GBP)?(\d{1,3}(?:\.\d{3})*(?:,\d{2}))(?:\$|£|€|USD|EUR|GBP)?(?:\s|$|, |\. )/, /(?:^|\s)(?:\$|£|€|USD|EUR|GBP)?(\d+)(?:\$|£|€|USD|EUR|GBP)?(?:\s|$|, |\. )/];
  const matches = [];
  const maybeLongestLowestMatch = (0, _matchLongestAtLowest.default)(formats, normalizedSubject);

  if (maybeLongestLowestMatch) {
    // eslint-disable-next-line flowtype/no-weak-types
    const match = {};
    let amount;

    if ((0, _isCommaCentSeparatorNotation.default)(maybeLongestLowestMatch.match)) {
      amount = (0, _parsePrice.default)(maybeLongestLowestMatch.match, '.,');
    } else if ((0, _isDotCentSeparatorNotation.default)(maybeLongestLowestMatch.match)) {
      amount = (0, _parsePrice.default)(maybeLongestLowestMatch.match, ',.');
    } else {
      amount = parseInt(maybeLongestLowestMatch.match, 10) * 100;
    }

    match.amount = amount;
    const subjectBeforeMatch = subject.slice(0, maybeLongestLowestMatch.index);
    const beforeCurrencySymbolMatch = subjectBeforeMatch.match(/([$|£|€])\s?$/);

    if (beforeCurrencySymbolMatch) {
      match.currencySymbol = beforeCurrencySymbolMatch[1];
    } else {
      const beforeCurrencyCodeMatch = subjectBeforeMatch.match(/[\^|\s]((?:USD|EUR|GBP))\s?$/);

      if (beforeCurrencyCodeMatch) {
        match.currencyCode = beforeCurrencyCodeMatch[1];
      } else {
        const subjectAfterMatch = subject.slice(maybeLongestLowestMatch.match.length + maybeLongestLowestMatch.index);
        const afterCurrencySymbolMatch = subjectAfterMatch.match(/^\s?([$|£|€])/);

        if (afterCurrencySymbolMatch) {
          match.currencySymbol = afterCurrencySymbolMatch[1];
        } else {
          const afterCurrencyCodeMatch = subjectAfterMatch.match(/^\s?((?:USD|EUR|GBP))[,|;|$|\s]/);

          if (afterCurrencyCodeMatch) {
            match.currencyCode = afterCurrencyCodeMatch[1];
          }
        }
      }
    }

    matches.push(match);
  }

  return matches;
};

exports.default = _default;
//# sourceMappingURL=extractPrice.js.map